Subject: Re: [PATCH v2] brmcfmac: fix compile when DEBUG is defined

From: Kalle Valo <[email-masked]>
Date: Mon, 7 Dec 2020 16:31:16 +0000 (UTC)

hby <[email-masked]> wrote:

> The steps:
> 1. add "#define DEBUG" in drivers/net/wireless/broadcom/brcm80211/brcmfmac/sdio.c line 61.
> 2. make ARCH=arm CROSS_COMPILE=arm-linux-gnueabihf- O=../Out_Linux bcm2835_defconfig
> 3. make ARCH=arm CROSS_COMPILE=arm-linux-gnueabihf- O=../Out_Linux/ zImage modules dtbs -j8
> 
> Then, it will fail, the compile log described below:
> 
> Kernel: arch/arm/boot/zImage is ready
> MODPOST Module.symvers
> ERROR: modpost: "brcmf_debugfs_add_entry" [drivers/net/wireless/broadcom/brcm80211/brcmfmac/brcmfmac.ko] undefined!
> ERROR: modpost: "brcmf_debugfs_get_devdir" [drivers/net/wireless/broadcom/brcm80211/brcmfmac/brcmfmac.ko] undefined!
> ERROR: modpost: "__brcmf_dbg" [drivers/net/wireless/broadcom/brcm80211/brcmfmac/brcmfmac.ko] undefined!
> scripts/Makefile.modpost:111: recipe for target 'Module.symvers' failed
> make[2]: *** [Module.symvers] Error 1
> make[2]: *** Deleting file 'Module.symvers'
> Makefile:1390: recipe for target 'modules' failed
> make[1]: *** [modules] Error 2
> make[1]: Leaving directory '/home/hby/gitee/linux_origin/Out_Linux'
> Makefile:185: recipe for target '__sub-make' failed
> make: *** [__sub-make] Error 2
> 
> Signed-off-by: hby <[email-masked]>

I checked and brcmd80211/Makefile has:

subdir-ccflags-$(CONFIG_BRCMDBG)	+= -DDEBUG

I don't understand why brcm80211 uses DEBUG flag like that, but I guess there's
a reason. I think that either _all_ DEBUG uses should be removed from the
driver, or you shouldn't add "#define DEBUG" on your own to any of the files.
So this patch is not the best solution.

-- 
https://patchwork.kernel.org/project/linux-wireless/patch/[email-masked]/

https://wireless.wiki.kernel.org/en/developers/documentation/submittingpatches